package dev.pfaff.altargui.host;

import dev.pfaff.altargui.text.Font;
import dev.pfaff.altargui.text.MinecraftBitmapFont;
import dev.pfaff.glass.opengl.GL;
import org.jspecify.annotations.Nullable;

import java.lang.foreign.MemorySegment;
import java.lang.foreign.SymbolLookup;

public interface Host {
	/**
	 * Constant value.
	 */
	default Font defaultFont() {
		return MinecraftBitmapFont.MINECRAFT_ASCII;
	}

	/**
	 * Constant value.
	 */
	IWindow window();

	@Nullable
	String getClipboardString();

	/**
	 * @param string the NUL-terminated string.
	 */
	void setClipboardString(MemorySegment string);

	/**
	 * Constant value.
	 */
	GL gl();

	SymbolLookup loadLibImage();
}
